       1: <?php
       2:
       3: namespace Thelia\Model\om;
       4:
       5: use \BasePeer;
       6: use \Criteria;
       7: use \PDO;
       8: use \PDOStatement;
       9: use \Propel;
      10: use \PropelException;
      11: use \PropelPDO;
      12: use Thelia\Model\AttributeAv;
      13: use Thelia\Model\AttributeAvI18nPeer;
      14: use Thelia\Model\AttributeAvPeer;
      15: use Thelia\Model\AttributeCombinationPeer;
      16: use Thelia\Model\AttributePeer;
      17: use Thelia\Model\map\AttributeAvTableMap;
      18:
      19: /**
      20:  * Base static class for performing query and update operations on the 'attribute_av' table.
      21:  *
      22:  *
      23:  *
      24:  * @package propel.generator.Thelia.Model.om
      25:  */
      26: abstract class BaseAttributeAvPeer
      27: {
      28:
      29:     /** the default database name for this class */
      30:     const DATABASE_NAME = 'thelia';
      31:
      32:     /** the table name for this class */
      33:     const TABLE_NAME = 'attribute_av';
      34:
      35:     /** the related Propel class for this table */
      36:     const OM_CLASS = 'Thelia\\Model\\AttributeAv';
      37:
      38:     /** the related TableMap class for this table */
      39:     const TM_CLASS = 'AttributeAvTableMap';
      40:
      41:     /** The total number of columns. */
      42:     const NUM_COLUMNS = 5;
      43:
      44:     /** The number of lazy-loaded columns. */
      45:     const NUM_LAZY_LOAD_COLUMNS = 0;
      46:
      47:     /** The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS) */
      48:     const NUM_HYDRATE_COLUMNS = 5;
      49:
      50:     /** the column name for the id field */
      51:     const ID = 'attribute_av.id';
      52:
      53:     /** the column name for the attribute_id field */
      54:     const ATTRIBUTE_ID = 'attribute_av.attribute_id';
      55:
      56:     /** the column name for the position field */
      57:     const POSITION = 'attribute_av.position';
      58:
      59:     /** the column name for the created_at field */
      60:     const CREATED_AT = 'attribute_av.created_at';
      61:
      62:     /** the column name for the updated_at field */
      63:     const UPDATED_AT = 'attribute_av.updated_at';
      64:
      65:     /** The default string format for model objects of the related table **/
      66:     const DEFAULT_STRING_FORMAT = 'YAML';
      67:
      68:     /**
      69:      * An identiy map to hold any loaded instances of AttributeAv objects.
      70:      * This must be public so that other peer classes can access this when hydrating from JOIN
      71:      * queries.
      72:      * @var        array AttributeAv[]
      73:      */
      74:     public static $instances = array();
      75:
      76:
      77:     // i18n behavior
      78:
      79:     /**
      80:      * The default locale to use for translations
      81:      * @var        string
      82:      */
      83:     const DEFAULT_LOCALE = 'en_US';
      84:     /**
      85:      * holds an array of fieldnames
      86:      *
      87:      * first dimension keys are the type constants
      88:      * e.g. AttributeAvPeer::$fieldNames[AttributeAvPeer::TYPE_PHPNAME][0] = 'Id'
      89:      */
      90:     protected static $fieldNames = array (
      91:         BasePeer::TYPE_PHPNAME => array ('Id', 'AttributeId', 'Position', 'CreatedAt', 'UpdatedAt', ),
      92:         BasePeer::TYPE_STUDLYPHPNAME => array ('id', 'attributeId', 'position', 'createdAt', 'updatedAt', ),
      93:         BasePeer::TYPE_COLNAME => array (AttributeAvPeer::ID, AttributeAvPeer::ATTRIBUTE_ID, AttributeAvPeer::POSITION, AttributeAvPeer::CREATED_AT, AttributeAvPeer::UPDATED_AT, ),
      94:         BasePeer::TYPE_RAW_COLNAME => array ('ID', 'ATTRIBUTE_ID', 'POSITION', 'CREATED_AT', 'UPDATED_AT', ),
      95:         BasePeer::TYPE_FIELDNAME => array ('id', 'attribute_id', 'position', 'created_at', 'updated_at', ),
      96:         BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, )
      97:     );
      98:
      99:     /**
     100:      * holds an array of keys for quick access to the fieldnames array
     101:      *
     102:      * first dimension keys are the type constants
     103:      * e.g. AttributeAvPeer::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
     104:      */
     105:     protected static $fieldKeys = array (
     106:         BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'AttributeId' => 1, 'Position' => 2, 'CreatedAt' => 3, 'UpdatedAt' => 4, ),
     107:         BasePeer::TYPE_STUDLYPHPNAME => array ('id' => 0, 'attributeId' => 1, 'position' => 2, 'createdAt' => 3, 'updatedAt' => 4, ),
     108:         BasePeer::TYPE_COLNAME => array (AttributeAvPeer::ID => 0, AttributeAvPeer::ATTRIBUTE_ID => 1, AttributeAvPeer::POSITION => 2, AttributeAvPeer::CREATED_AT => 3, AttributeAvPeer::UPDATED_AT => 4, ),
     109:         BasePeer::TYPE_RAW_COLNAME => array ('ID' => 0, 'ATTRIBUTE_ID' => 1, 'POSITION' => 2, 'CREATED_AT' => 3, 'UPDATED_AT' => 4, ),
     110:         BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'attribute_id' => 1, 'position' => 2, 'created_at' => 3, 'updated_at' => 4, ),
     111:         BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, )
     112:     );
     113:
     114:     /**
     115:      * Translates a fieldname to another type
     116:      *
     117:      * @param      string $name field name
     118:      * @param      string $fromType One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     119:      *                         BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     120:      * @param      string $toType   One of the class type constants
     121:      * @return string          translated name of the field.
     122:      * @throws PropelException - if the specified name could not be found in the fieldname mappings.
     123:      */
     124:     public static function translateFieldName($name, $fromType, $toType)
     125:     {
     126:         $toNames = AttributeAvPeer::getFieldNames($toType);
     127:         $key = isset(AttributeAvPeer::$fieldKeys[$fromType][$name]) ? AttributeAvPeer::$fieldKeys[$fromType][$name] : null;
     128:         if ($key === null) {
     129:             throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(AttributeAvPeer::$fieldKeys[$fromType], true));
     130:         }
     131:
     132:         return $toNames[$key];
     133:     }
     134:
     135:     /**
     136:      * Returns an array of field names.
     137:      *
     138:      * @param      string $type The type of fieldnames to return:
     139:      *                      One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     140:      *                      BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     141:      * @return array           A list of field names
     142:      * @throws PropelException - if the type is not valid.
     143:      */
     144:     public static function getFieldNames($type = BasePeer::TYPE_PHPNAME)
     145:     {
     146:         if (!array_key_exists($type, AttributeAvPeer::$fieldNames)) {
     147:             throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
     148:         }
     149:
     150:         return AttributeAvPeer::$fieldNames[$type];
     151:     }
     152:
     153:     /**
     154:      * Convenience method which changes table.column to alias.column.
     155:      *
     156:      * Using this method you can maintain SQL abstraction while using column aliases.
     157:      * <code>
     158:      *      $c->addAlias("alias1", TablePeer::TABLE_NAME);
     159:      *      $c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
     160:      * </code>
     161:      * @param      string $alias The alias for the current table.
     162:      * @param      string $column The column name for current table. (i.e. AttributeAvPeer::COLUMN_NAME).
     163:      * @return string
     164:      */
     165:     public static function alias($alias, $column)
     166:     {
     167:         return str_replace(AttributeAvPeer::TABLE_NAME.'.', $alias.'.', $column);
     168:     }
     169:
     170:     /**
     171:      * Add all the columns needed to create a new object.
     172:      *
     173:      * Note: any columns that were marked with lazyLoad="true" in the
     174:      * XML schema will not be added to the select list and only loaded
     175:      * on demand.
     176:      *
     177:      * @param      Criteria $criteria object containing the columns to add.
     178:      * @param      string   $alias    optional table alias
     179:      * @throws PropelException Any exceptions caught during processing will be
     180:      *       rethrown wrapped into a PropelException.
     181:      */
     182:     public static function addSelectColumns(Criteria $criteria, $alias = null)
     183:     {
     184:         if (null === $alias) {
     185:             $criteria->addSelectColumn(AttributeAvPeer::ID);
     186:             $criteria->addSelectColumn(AttributeAvPeer::ATTRIBUTE_ID);
     187:             $criteria->addSelectColumn(AttributeAvPeer::POSITION);
     188:             $criteria->addSelectColumn(AttributeAvPeer::CREATED_AT);
     189:             $criteria->addSelectColumn(AttributeAvPeer::UPDATED_AT);
     190:         } else {
     191:             $criteria->addSelectColumn($alias . '.id');
     192:             $criteria->addSelectColumn($alias . '.attribute_id');
     193:             $criteria->addSelectColumn($alias . '.position');
     194:             $criteria->addSelectColumn($alias . '.created_at');
     195:             $criteria->addSelectColumn($alias . '.updated_at');
     196:         }
     197:     }
     198:
     199:     /**
     200:      * Returns the number of rows matching criteria.
     201:      *
     202:      * @param      Criteria $criteria
     203:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     204:      * @param      PropelPDO $con
     205:      * @return int Number of matching rows.
     206:      */
     207:     public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
     208:     {
     209:         // we may modify criteria, so copy it first
     210:         $criteria = clone $criteria;
     211:
     212:         // We need to set the primary table name, since in the case that there are no WHERE columns
     213:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
     214:         // tables go into the FROM clause.
     215:         $criteria->setPrimaryTableName(AttributeAvPeer::TABLE_NAME);
     216:
     217:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
     218:             $criteria->setDistinct();
     219:         }
     220:
     221:         if (!$criteria->hasSelectClause()) {
     222:             AttributeAvPeer::addSelectColumns($criteria);
     223:         }
     224:
     225:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
     226:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME); // Set the correct dbName
     227:
     228:         if ($con === null) {
     229:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     230:         }
     231:         // BasePeer returns a PDOStatement
     232:         $stmt = BasePeer::doCount($criteria, $con);
     233:
     234:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     235:             $count = (int) $row[0];
     236:         } else {
     237:             $count = 0; // no rows returned; we infer that means 0 matches.
     238:         }
     239:         $stmt->closeCursor();
     240:
     241:         return $count;
     242:     }
     243:     /**
     244:      * Selects one object from the DB.
     245:      *
     246:      * @param      Criteria $criteria object used to create the SELECT statement.
     247:      * @param      PropelPDO $con
     248:      * @return                 AttributeAv
     249:      * @throws PropelException Any exceptions caught during processing will be
     250:      *       rethrown wrapped into a PropelException.
     251:      */
     252:     public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
     253:     {
     254:         $critcopy = clone $criteria;
     255:         $critcopy->setLimit(1);
     256:         $objects = AttributeAvPeer::doSelect($critcopy, $con);
     257:         if ($objects) {
     258:             return $objects[0];
     259:         }
     260:
     261:         return null;
     262:     }
     263:     /**
     264:      * Selects several row from the DB.
     265:      *
     266:      * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     267:      * @param      PropelPDO $con
     268:      * @return array           Array of selected Objects
     269:      * @throws PropelException Any exceptions caught during processing will be
     270:      *       rethrown wrapped into a PropelException.
     271:      */
     272:     public static function doSelect(Criteria $criteria, PropelPDO $con = null)
     273:     {
     274:         return AttributeAvPeer::populateObjects(AttributeAvPeer::doSelectStmt($criteria, $con));
     275:     }
     276:     /**
     277:      * Prepares the Criteria object and uses the parent doSelect() method to execute a PDOStatement.
     278:      *
     279:      * Use this method directly if you want to work with an executed statement directly (for example
     280:      * to perform your own object hydration).
     281:      *
     282:      * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     283:      * @param      PropelPDO $con The connection to use
     284:      * @throws PropelException Any exceptions caught during processing will be
     285:      *       rethrown wrapped into a PropelException.
     286:      * @return PDOStatement The executed PDOStatement object.
     287:      * @see        BasePeer::doSelect()
     288:      */
     289:     public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
     290:     {
     291:         if ($con === null) {
     292:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     293:         }
     294:
     295:         if (!$criteria->hasSelectClause()) {
     296:             $criteria = clone $criteria;
     297:             AttributeAvPeer::addSelectColumns($criteria);
     298:         }
     299:
     300:         // Set the correct dbName
     301:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     302:
     303:         // BasePeer returns a PDOStatement
     304:         return BasePeer::doSelect($criteria, $con);
     305:     }
     306:     /**
     307:      * Adds an object to the instance pool.
     308:      *
     309:      * Propel keeps cached copies of objects in an instance pool when they are retrieved
     310:      * from the database.  In some cases -- especially when you override doSelect*()
     311:      * methods in your stub classes -- you may need to explicitly add objects
     312:      * to the cache in order to ensure that the same objects are always returned by doSelect*()
     313:      * and retrieveByPK*() calls.
     314:      *
     315:      * @param      AttributeAv $obj A AttributeAv object.
     316:      * @param      string $key (optional) key to use for instance map (for performance boost if key was already calculated externally).
     317:      */
     318:     public static function addInstanceToPool($obj, $key = null)
     319:     {
     320:         if (Propel::isInstancePoolingEnabled()) {
     321:             if ($key === null) {
     322:                 $key = (string) $obj->getId();
     323:             } // if key === null
     324:             AttributeAvPeer::$instances[$key] = $obj;
     325:         }
     326:     }
     327:
     328:     /**
     329:      * Removes an object from the instance pool.
     330:      *
     331:      * Propel keeps cached copies of objects in an instance pool when they are retrieved
     332:      * from the database.  In some cases -- especially when you override doDelete
     333:      * methods in your stub classes -- you may need to explicitly remove objects
     334:      * from the cache in order to prevent returning objects that no longer exist.
     335:      *
     336:      * @param      mixed $value A AttributeAv object or a primary key value.
     337:      *
     338:      * @return void
     339:      * @throws PropelException - if the value is invalid.
     340:      */
     341:     public static function removeInstanceFromPool($value)
     342:     {
     343:         if (Propel::isInstancePoolingEnabled() && $value !== null) {
     344:             if (is_object($value) && $value instanceof AttributeAv) {
     345:                 $key = (string) $value->getId();
     346:             } elseif (is_scalar($value)) {
     347:                 // assume we've been passed a primary key
     348:                 $key = (string) $value;
     349:             } else {
     350:                 $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or AttributeAv object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
     351:                 throw $e;
     352:             }
     353:
     354:             unset(AttributeAvPeer::$instances[$key]);
     355:         }
     356:     } // removeInstanceFromPool()
     357:
     358:     /**
     359:      * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     360:      *
     361:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     362:      * a multi-column primary key, a serialize()d version of the primary key will be returned.
     363:      *
     364:      * @param      string $key The key (@see getPrimaryKeyHash()) for this instance.
     365:      * @return   AttributeAv Found object or null if 1) no instance exists for specified key or 2) instance pooling has been disabled.
     366:      * @see        getPrimaryKeyHash()
     367:      */
     368:     public static function getInstanceFromPool($key)
     369:     {
     370:         if (Propel::isInstancePoolingEnabled()) {
     371:             if (isset(AttributeAvPeer::$instances[$key])) {
     372:                 return AttributeAvPeer::$instances[$key];
     373:             }
     374:         }
     375:
     376:         return null; // just to be explicit
     377:     }
     378:
     379:     /**
     380:      * Clear the instance pool.
     381:      *
     382:      * @return void
     383:      */
     384:     public static function clearInstancePool($and_clear_all_references = false)
     385:     {
     386:       if ($and_clear_all_references)
     387:       {
     388:         foreach (AttributeAvPeer::$instances as $instance)
     389:         {
     390:           $instance->clearAllReferences(true);
     391:         }
     392:       }
     393:         AttributeAvPeer::$instances = array();
     394:     }
     395:
     396:     /**
     397:      * Method to invalidate the instance pool of all tables related to attribute_av
     398:      * by a foreign key with ON DELETE CASCADE
     399:      */
     400:     public static function clearRelatedInstancePool()
     401:     {
     402:         // Invalidate objects in AttributeCombinationPeer instance pool,
     403:         // since one or more of them may be deleted by ON DELETE CASCADE/SETNULL rule.
     404:         AttributeCombinationPeer::clearInstancePool();
     405:         // Invalidate objects in AttributeAvI18nPeer instance pool,
     406:         // since one or more of them may be deleted by ON DELETE CASCADE/SETNULL rule.
     407:         AttributeAvI18nPeer::clearInstancePool();
     408:     }
     409:
     410:     /**
     411:      * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     412:      *
     413:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     414:      * a multi-column primary key, a serialize()d version of the primary key will be returned.
     415:      *
     416:      * @param      array $row PropelPDO resultset row.
     417:      * @param      int $startcol The 0-based offset for reading from the resultset row.
     418:      * @return string A string version of PK or null if the components of primary key in result array are all null.
     419:      */
     420:     public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
     421:     {
     422:         // If the PK cannot be derived from the row, return null.
     423:         if ($row[$startcol] === null) {
     424:             return null;
     425:         }
     426:
     427:         return (string) $row[$startcol];
     428:     }
     429:
     430:     /**
     431:      * Retrieves the primary key from the DB resultset row
     432:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     433:      * a multi-column primary key, an array of the primary key columns will be returned.
     434:      *
     435:      * @param      array $row PropelPDO resultset row.
     436:      * @param      int $startcol The 0-based offset for reading from the resultset row.
     437:      * @return mixed The primary key of the row
     438:      */
     439:     public static function getPrimaryKeyFromRow($row, $startcol = 0)
     440:     {
     441:
     442:         return (int) $row[$startcol];
     443:     }
     444:
     445:     /**
     446:      * The returned array will contain objects of the default type or
     447:      * objects that inherit from the default.
     448:      *
     449:      * @throws PropelException Any exceptions caught during processing will be
     450:      *       rethrown wrapped into a PropelException.
     451:      */
     452:     public static function populateObjects(PDOStatement $stmt)
     453:     {
     454:         $results = array();
     455:
     456:         // set the class once to avoid overhead in the loop
     457:         $cls = AttributeAvPeer::getOMClass();
     458:         // populate the object(s)
     459:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     460:             $key = AttributeAvPeer::getPrimaryKeyHashFromRow($row, 0);
     461:             if (null !== ($obj = AttributeAvPeer::getInstanceFromPool($key))) {
     462:                 // We no longer rehydrate the object, since this can cause data loss.
     463:                 // See http://www.propelorm.org/ticket/509
     464:                 // $obj->hydrate($row, 0, true); // rehydrate
     465:                 $results[] = $obj;
     466:             } else {
     467:                 $obj = new $cls();
     468:                 $obj->hydrate($row);
     469:                 $results[] = $obj;
     470:                 AttributeAvPeer::addInstanceToPool($obj, $key);
     471:             } // if key exists
     472:         }
     473:         $stmt->closeCursor();
     474:
     475:         return $results;
     476:     }
     477:     /**
     478:      * Populates an object of the default type or an object that inherit from the default.
     479:      *
     480:      * @param      array $row PropelPDO resultset row.
     481:      * @param      int $startcol The 0-based offset for reading from the resultset row.
     482:      * @throws PropelException Any exceptions caught during processing will be
     483:      *       rethrown wrapped into a PropelException.
     484:      * @return array (AttributeAv object, last column rank)
     485:      */
     486:     public static function populateObject($row, $startcol = 0)
     487:     {
     488:         $key = AttributeAvPeer::getPrimaryKeyHashFromRow($row, $startcol);
     489:         if (null !== ($obj = AttributeAvPeer::getInstanceFromPool($key))) {
     490:             // We no longer rehydrate the object, since this can cause data loss.
     491:             // See http://www.propelorm.org/ticket/509
     492:             // $obj->hydrate($row, $startcol, true); // rehydrate
     493:             $col = $startcol + AttributeAvPeer::NUM_HYDRATE_COLUMNS;
     494:         } else {
     495:             $cls = AttributeAvPeer::OM_CLASS;
     496:             $obj = new $cls();
     497:             $col = $obj->hydrate($row, $startcol);
     498:             AttributeAvPeer::addInstanceToPool($obj, $key);
     499:         }
     500:
     501:         return array($obj, $col);
     502:     }
     503:
     504:
     505:     /**
     506:      * Returns the number of rows matching criteria, joining the related Attribute table
     507:      *
     508:      * @param      Criteria $criteria
     509:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     510:      * @param      PropelPDO $con
     511:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     512:      * @return int Number of matching rows.
     513:      */
     514:     public static function doCountJoinAttribute(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
     515:     {
     516:         // we're going to modify criteria, so copy it first
     517:         $criteria = clone $criteria;
     518:
     519:         // We need to set the primary table name, since in the case that there are no WHERE columns
     520:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
     521:         // tables go into the FROM clause.
     522:         $criteria->setPrimaryTableName(AttributeAvPeer::TABLE_NAME);
     523:
     524:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
     525:             $criteria->setDistinct();
     526:         }
     527:
     528:         if (!$criteria->hasSelectClause()) {
     529:             AttributeAvPeer::addSelectColumns($criteria);
     530:         }
     531:
     532:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
     533:
     534:         // Set the correct dbName
     535:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     536:
     537:         if ($con === null) {
     538:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     539:         }
     540:
     541:         $criteria->addJoin(AttributeAvPeer::ATTRIBUTE_ID, AttributePeer::ID, $join_behavior);
     542:
     543:         $stmt = BasePeer::doCount($criteria, $con);
     544:
     545:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     546:             $count = (int) $row[0];
     547:         } else {
     548:             $count = 0; // no rows returned; we infer that means 0 matches.
     549:         }
     550:         $stmt->closeCursor();
     551:
     552:         return $count;
     553:     }
     554:
     555:
     556:     /**
     557:      * Selects a collection of AttributeAv objects pre-filled with their Attribute objects.
     558:      * @param      Criteria  $criteria
     559:      * @param      PropelPDO $con
     560:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     561:      * @return array           Array of AttributeAv objects.
     562:      * @throws PropelException Any exceptions caught during processing will be
     563:      *       rethrown wrapped into a PropelException.
     564:      */
     565:     public static function doSelectJoinAttribute(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
     566:     {
     567:         $criteria = clone $criteria;
     568:
     569:         // Set the correct dbName if it has not been overridden
     570:         if ($criteria->getDbName() == Propel::getDefaultDB()) {
     571:             $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     572:         }
     573:
     574:         AttributeAvPeer::addSelectColumns($criteria);
     575:         $startcol = AttributeAvPeer::NUM_HYDRATE_COLUMNS;
     576:         AttributePeer::addSelectColumns($criteria);
     577:
     578:         $criteria->addJoin(AttributeAvPeer::ATTRIBUTE_ID, AttributePeer::ID, $join_behavior);
     579:
     580:         $stmt = BasePeer::doSelect($criteria, $con);
     581:         $results = array();
     582:
     583:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     584:             $key1 = AttributeAvPeer::getPrimaryKeyHashFromRow($row, 0);
     585:             if (null !== ($obj1 = AttributeAvPeer::getInstanceFromPool($key1))) {
     586:                 // We no longer rehydrate the object, since this can cause data loss.
     587:                 // See http://www.propelorm.org/ticket/509
     588:                 // $obj1->hydrate($row, 0, true); // rehydrate
     589:             } else {
     590:
     591:                 $cls = AttributeAvPeer::getOMClass();
     592:
     593:                 $obj1 = new $cls();
     594:                 $obj1->hydrate($row);
     595:                 AttributeAvPeer::addInstanceToPool($obj1, $key1);
     596:             } // if $obj1 already loaded
     597:
     598:             $key2 = AttributePeer::getPrimaryKeyHashFromRow($row, $startcol);
     599:             if ($key2 !== null) {
     600:                 $obj2 = AttributePeer::getInstanceFromPool($key2);
     601:                 if (!$obj2) {
     602:
     603:                     $cls = AttributePeer::getOMClass();
     604:
     605:                     $obj2 = new $cls();
     606:                     $obj2->hydrate($row, $startcol);
     607:                     AttributePeer::addInstanceToPool($obj2, $key2);
     608:                 } // if obj2 already loaded
     609:
     610:                 // Add the $obj1 (AttributeAv) to $obj2 (Attribute)
     611:                 $obj2->addAttributeAv($obj1);
     612:
     613:             } // if joined row was not null
     614:
     615:             $results[] = $obj1;
     616:         }
     617:         $stmt->closeCursor();
     618:
     619:         return $results;
     620:     }
     621:
     622:
     623:     /**
     624:      * Returns the number of rows matching criteria, joining all related tables
     625:      *
     626:      * @param      Criteria $criteria
     627:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     628:      * @param      PropelPDO $con
     629:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     630:      * @return int Number of matching rows.
     631:      */
     632:     public static function doCountJoinAll(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
     633:     {
     634:         // we're going to modify criteria, so copy it first
     635:         $criteria = clone $criteria;
     636:
     637:         // We need to set the primary table name, since in the case that there are no WHERE columns
     638:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
     639:         // tables go into the FROM clause.
     640:         $criteria->setPrimaryTableName(AttributeAvPeer::TABLE_NAME);
     641:
     642:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
     643:             $criteria->setDistinct();
     644:         }
     645:
     646:         if (!$criteria->hasSelectClause()) {
     647:             AttributeAvPeer::addSelectColumns($criteria);
     648:         }
     649:
     650:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
     651:
     652:         // Set the correct dbName
     653:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     654:
     655:         if ($con === null) {
     656:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     657:         }
     658:
     659:         $criteria->addJoin(AttributeAvPeer::ATTRIBUTE_ID, AttributePeer::ID, $join_behavior);
     660:
     661:         $stmt = BasePeer::doCount($criteria, $con);
     662:
     663:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     664:             $count = (int) $row[0];
     665:         } else {
     666:             $count = 0; // no rows returned; we infer that means 0 matches.
     667:         }
     668:         $stmt->closeCursor();
     669:
     670:         return $count;
     671:     }
     672:
     673:     /**
     674:      * Selects a collection of AttributeAv objects pre-filled with all related objects.
     675:      *
     676:      * @param      Criteria  $criteria
     677:      * @param      PropelPDO $con
     678:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     679:      * @return array           Array of AttributeAv objects.
     680:      * @throws PropelException Any exceptions caught during processing will be
     681:      *       rethrown wrapped into a PropelException.
     682:      */
     683:     public static function doSelectJoinAll(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
     684:     {
     685:         $criteria = clone $criteria;
     686:
     687:         // Set the correct dbName if it has not been overridden
     688:         if ($criteria->getDbName() == Propel::getDefaultDB()) {
     689:             $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     690:         }
     691:
     692:         AttributeAvPeer::addSelectColumns($criteria);
     693:         $startcol2 = AttributeAvPeer::NUM_HYDRATE_COLUMNS;
     694:
     695:         AttributePeer::addSelectColumns($criteria);
     696:         $startcol3 = $startcol2 + AttributePeer::NUM_HYDRATE_COLUMNS;
     697:
     698:         $criteria->addJoin(AttributeAvPeer::ATTRIBUTE_ID, AttributePeer::ID, $join_behavior);
     699:
     700:         $stmt = BasePeer::doSelect($criteria, $con);
     701:         $results = array();
     702:
     703:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     704:             $key1 = AttributeAvPeer::getPrimaryKeyHashFromRow($row, 0);
     705:             if (null !== ($obj1 = AttributeAvPeer::getInstanceFromPool($key1))) {
     706:                 // We no longer rehydrate the object, since this can cause data loss.
     707:                 // See http://www.propelorm.org/ticket/509
     708:                 // $obj1->hydrate($row, 0, true); // rehydrate
     709:             } else {
     710:                 $cls = AttributeAvPeer::getOMClass();
     711:
     712:                 $obj1 = new $cls();
     713:                 $obj1->hydrate($row);
     714:                 AttributeAvPeer::addInstanceToPool($obj1, $key1);
     715:             } // if obj1 already loaded
     716:
     717:             // Add objects for joined Attribute rows
     718:
     719:             $key2 = AttributePeer::getPrimaryKeyHashFromRow($row, $startcol2);
     720:             if ($key2 !== null) {
     721:                 $obj2 = AttributePeer::getInstanceFromPool($key2);
     722:                 if (!$obj2) {
     723:
     724:                     $cls = AttributePeer::getOMClass();
     725:
     726:                     $obj2 = new $cls();
     727:                     $obj2->hydrate($row, $startcol2);
     728:                     AttributePeer::addInstanceToPool($obj2, $key2);
     729:                 } // if obj2 loaded
     730:
     731:                 // Add the $obj1 (AttributeAv) to the collection in $obj2 (Attribute)
     732:                 $obj2->addAttributeAv($obj1);
     733:             } // if joined row not null
     734:
     735:             $results[] = $obj1;
     736:         }
     737:         $stmt->closeCursor();
     738:
     739:         return $results;
     740:     }
     741:
     742:     /**
     743:      * Returns the TableMap related to this peer.
     744:      * This method is not needed for general use but a specific application could have a need.
     745:      * @return TableMap
     746:      * @throws PropelException Any exceptions caught during processing will be
     747:      *       rethrown wrapped into a PropelException.
     748:      */
     749:     public static function getTableMap()
     750:     {
     751:         return Propel::getDatabaseMap(AttributeAvPeer::DATABASE_NAME)->getTable(AttributeAvPeer::TABLE_NAME);
     752:     }
     753:
     754:     /**
     755:      * Add a TableMap instance to the database for this peer class.
     756:      */
     757:     public static function buildTableMap()
     758:     {
     759:       $dbMap = Propel::getDatabaseMap(BaseAttributeAvPeer::DATABASE_NAME);
     760:       if (!$dbMap->hasTable(BaseAttributeAvPeer::TABLE_NAME)) {
     761:         $dbMap->addTableObject(new AttributeAvTableMap());
     762:       }
     763:     }
     764:
     765:     /**
     766:      * The class that the Peer will make instances of.
     767:      *
     768:      *
     769:      * @return string ClassName
     770:      */
     771:     public static function getOMClass($row = 0, $colnum = 0)
     772:     {
     773:         return AttributeAvPeer::OM_CLASS;
     774:     }
     775:
     776:     /**
     777:      * Performs an INSERT on the database, given a AttributeAv or Criteria object.
     778:      *
     779:      * @param      mixed $values Criteria or AttributeAv object containing data that is used to create the INSERT statement.
     780:      * @param      PropelPDO $con the PropelPDO connection to use
     781:      * @return mixed           The new primary key.
     782:      * @throws PropelException Any exceptions caught during processing will be
     783:      *       rethrown wrapped into a PropelException.
     784:      */
     785:     public static function doInsert($values, PropelPDO $con = null)
     786:     {
     787:         if ($con === null) {
     788:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     789:         }
     790:
     791:         if ($values instanceof Criteria) {
     792:             $criteria = clone $values; // rename for clarity
     793:         } else {
     794:             $criteria = $values->buildCriteria(); // build Criteria from AttributeAv object
     795:         }
     796:
     797:         if ($criteria->containsKey(AttributeAvPeer::ID) && $criteria->keyContainsValue(AttributeAvPeer::ID) ) {
     798:             throw new PropelException('Cannot insert a value for auto-increment primary key ('.AttributeAvPeer::ID.')');
     799:         }
     800:
     801:
     802:         // Set the correct dbName
     803:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     804:
     805:         try {
     806:             // use transaction because $criteria could contain info
     807:             // for more than one table (I guess, conceivably)
     808:             $con->beginTransaction();
     809:             $pk = BasePeer::doInsert($criteria, $con);
     810:             $con->commit();
     811:         } catch (PropelException $e) {
     812:             $con->rollBack();
     813:             throw $e;
     814:         }
     815:
     816:         return $pk;
     817:     }
     818:
     819:     /**
     820:      * Performs an UPDATE on the database, given a AttributeAv or Criteria object.
     821:      *
     822:      * @param      mixed $values Criteria or AttributeAv object containing data that is used to create the UPDATE statement.
     823:      * @param      PropelPDO $con The connection to use (specify PropelPDO connection object to exert more control over transactions).
     824:      * @return int             The number of affected rows (if supported by underlying database driver).
     825:      * @throws PropelException Any exceptions caught during processing will be
     826:      *       rethrown wrapped into a PropelException.
     827:      */
     828:     public static function doUpdate($values, PropelPDO $con = null)
     829:     {
     830:         if ($con === null) {
     831:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     832:         }
     833:
     834:         $selectCriteria = new Criteria(AttributeAvPeer::DATABASE_NAME);
     835:
     836:         if ($values instanceof Criteria) {
     837:             $criteria = clone $values; // rename for clarity
     838:
     839:             $comparison = $criteria->getComparison(AttributeAvPeer::ID);
     840:             $value = $criteria->remove(AttributeAvPeer::ID);
     841:             if ($value) {
     842:                 $selectCriteria->add(AttributeAvPeer::ID, $value, $comparison);
     843:             } else {
     844:                 $selectCriteria->setPrimaryTableName(AttributeAvPeer::TABLE_NAME);
     845:             }
     846:
     847:         } else { // $values is AttributeAv object
     848:             $criteria = $values->buildCriteria(); // gets full criteria
     849:             $selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
     850:         }
     851:
     852:         // set the correct dbName
     853:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     854:
     855:         return BasePeer::doUpdate($selectCriteria, $criteria, $con);
     856:     }
     857:
     858:     /**
     859:      * Deletes all rows from the attribute_av table.
     860:      *
     861:      * @param      PropelPDO $con the connection to use
     862:      * @return int             The number of affected rows (if supported by underlying database driver).
     863:      * @throws PropelException
     864:      */
     865:     public static function doDeleteAll(PropelPDO $con = null)
     866:     {
     867:         if ($con === null) {
     868:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     869:         }
     870:         $affectedRows = 0; // initialize var to track total num of affected rows
     871:         try {
     872:             // use transaction because $criteria could contain info
     873:             // for more than one table or we could emulating ON DELETE CASCADE, etc.
     874:             $con->beginTransaction();
     875:             $affectedRows += BasePeer::doDeleteAll(AttributeAvPeer::TABLE_NAME, $con, AttributeAvPeer::DATABASE_NAME);
     876:             // Because this db requires some delete cascade/set null emulation, we have to
     877:             // clear the cached instance *after* the emulation has happened (since
     878:             // instances get re-added by the select statement contained therein).
     879:             AttributeAvPeer::clearInstancePool();
     880:             AttributeAvPeer::clearRelatedInstancePool();
     881:             $con->commit();
     882:
     883:             return $affectedRows;
     884:         } catch (PropelException $e) {
     885:             $con->rollBack();
     886:             throw $e;
     887:         }
     888:     }
     889:
     890:     /**
     891:      * Performs a DELETE on the database, given a AttributeAv or Criteria object OR a primary key value.
     892:      *
     893:      * @param      mixed $values Criteria or AttributeAv object or primary key or array of primary keys
     894:      *              which is used to create the DELETE statement
     895:      * @param      PropelPDO $con the connection to use
     896:      * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     897:      *              if supported by native driver or if emulated using Propel.
     898:      * @throws PropelException Any exceptions caught during processing will be
     899:      *       rethrown wrapped into a PropelException.
     900:      */
     901:      public static function doDelete($values, PropelPDO $con = null)
     902:      {
     903:         if ($con === null) {
     904:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     905:         }
     906:
     907:         if ($values instanceof Criteria) {
     908:             // invalidate the cache for all objects of this type, since we have no
     909:             // way of knowing (without running a query) what objects should be invalidated
     910:             // from the cache based on this Criteria.
     911:             AttributeAvPeer::clearInstancePool();
     912:             // rename for clarity
     913:             $criteria = clone $values;
     914:         } elseif ($values instanceof AttributeAv) { // it's a model object
     915:             // invalidate the cache for this single object
     916:             AttributeAvPeer::removeInstanceFromPool($values);
     917:             // create criteria based on pk values
     918:             $criteria = $values->buildPkeyCriteria();
     919:         } else { // it's a primary key, or an array of pks
     920:             $criteria = new Criteria(AttributeAvPeer::DATABASE_NAME);
     921:             $criteria->add(AttributeAvPeer::ID, (array) $values, Criteria::IN);
     922:             // invalidate the cache for this object(s)
     923:             foreach ((array) $values as $singleval) {
     924:                 AttributeAvPeer::removeInstanceFromPool($singleval);
     925:             }
     926:         }
     927:
     928:         // Set the correct dbName
     929:         $criteria->setDbName(AttributeAvPeer::DATABASE_NAME);
     930:
     931:         $affectedRows = 0; // initialize var to track total num of affected rows
     932:
     933:         try {
     934:             // use transaction because $criteria could contain info
     935:             // for more than one table or we could emulating ON DELETE CASCADE, etc.
     936:             $con->beginTransaction();
     937:
     938:             $affectedRows += BasePeer::doDelete($criteria, $con);
     939:             AttributeAvPeer::clearRelatedInstancePool();
     940:             $con->commit();
     941:
     942:             return $affectedRows;
     943:         } catch (PropelException $e) {
     944:             $con->rollBack();
     945:             throw $e;
     946:         }
     947:     }
     948:
     949:     /**
     950:      * Validates all modified columns of given AttributeAv object.
     951:      * If parameter $columns is either a single column name or an array of column names
     952:      * than only those columns are validated.
     953:      *
     954:      * NOTICE: This does not apply to primary or foreign keys for now.
     955:      *
     956:      * @param      AttributeAv $obj The object to validate.
     957:      * @param      mixed $cols Column name or array of column names.
     958:      *
     959:      * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
     960:      */
     961:     public static function doValidate($obj, $cols = null)
     962:     {
     963:         $columns = array();
     964:
     965:         if ($cols) {
     966:             $dbMap = Propel::getDatabaseMap(AttributeAvPeer::DATABASE_NAME);
     967:             $tableMap = $dbMap->getTable(AttributeAvPeer::TABLE_NAME);
     968:
     969:             if (! is_array($cols)) {
     970:                 $cols = array($cols);
     971:             }
     972:
     973:             foreach ($cols as $colName) {
     974:                 if ($tableMap->hasColumn($colName)) {
     975:                     $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
     976:                     $columns[$colName] = $obj->$get();
     977:                 }
     978:             }
     979:         } else {
     980:
     981:         }
     982:
     983:         return BasePeer::doValidate(AttributeAvPeer::DATABASE_NAME, AttributeAvPeer::TABLE_NAME, $columns);
     984:     }
     985:
     986:     /**
     987:      * Retrieve a single object by pkey.
     988:      *
     989:      * @param      int $pk the primary key.
     990:      * @param      PropelPDO $con the connection to use
     991:      * @return AttributeAv
     992:      */
     993:     public static function retrieveByPK($pk, PropelPDO $con = null)
     994:     {
     995:
     996:         if (null !== ($obj = AttributeAvPeer::getInstanceFromPool((string) $pk))) {
     997:             return $obj;
     998:         }
     999:
    1000:         if ($con === null) {
    1001:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
    1002:         }
    1003:
    1004:         $criteria = new Criteria(AttributeAvPeer::DATABASE_NAME);
    1005:         $criteria->add(AttributeAvPeer::ID, $pk);
    1006:
    1007:         $v = AttributeAvPeer::doSelect($criteria, $con);
    1008:
    1009:         return !empty($v) > 0 ? $v[0] : null;
    1010:     }
    1011:
    1012:     /**
    1013:      * Retrieve multiple objects by pkey.
    1014:      *
    1015:      * @param      array $pks List of primary keys
    1016:      * @param      PropelPDO $con the connection to use
    1017:      * @return AttributeAv[]
    1018:      * @throws PropelException Any exceptions caught during processing will be
    1019:      *       rethrown wrapped into a PropelException.
    1020:      */
    1021:     public static function retrieveByPKs($pks, PropelPDO $con = null)
    1022:     {
    1023:         if ($con === null) {
    1024:             $con = Propel::getConnection(AttributeAvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
    1025:         }
    1026:
    1027:         $objs = null;
    1028:         if (empty($pks)) {
    1029:             $objs = array();
    1030:         } else {
    1031:             $criteria = new Criteria(AttributeAvPeer::DATABASE_NAME);
    1032:             $criteria->add(AttributeAvPeer::ID, $pks, Criteria::IN);
    1033:             $objs = AttributeAvPeer::doSelect($criteria, $con);
    1034:         }
    1035:
    1036:         return $objs;
    1037:     }
    1038:
    1039: } // BaseAttributeAvPeer
    1040:
    1041: // This is the static code needed to register the TableMap for this table with the main Propel class.
    1042: //
    1043: BaseAttributeAvPeer::buildTableMap();
    1044:
    1045: